/***************************************************************************
                                MaskImage.h
                             ------------------
    begin                : 28.11.2005
    copyright            : (C) 2005 by Frank Moosmann and INRIA
    email                : moosmann@mrt.uka.de
 ***************************************************************************/

#ifndef MASKIMAGE_H
#define MASKIMAGE_H

#include <Magick++.h>
#include <string>

class MaskImage {

public:
  
  MaskImage(std::string filename, unsigned int im_width, unsigned int im_height);
  ~MaskImage();
  double getObjBgrRatio(unsigned int width, unsigned int height, unsigned int offset_x, unsigned int offset_y);
  void printIntoFile(std::string filename);  // for debug purposes

private:
  Magick::Image sourceImage;
  unsigned int **maskIntegral;
  unsigned int imWidth;
  unsigned int imHeight;
  void createMaskIntegral();
  void deleteMaskIntegral();
};
#endif //MASKIMAGE_H
