//***************************************************************************
//                          FRank's IMage CLAssifier
//                             -------------------
//    begin                : 04.11.2005
//    copyright            : (C) 2005 by Frank Moosmann and INRIA
//    email                : moosmann@mrt.uka.de
//***************************************************************************

// Hopefully you will never have to edit this file!
// I know it's a big mess, but I did not have time for refactoring
// All the other classes, the Trees, Feature Extractors etc are
// programmed in a much better way!

#include "FMUtils.h"
#include "FeatureVector.h"
# include "FeatureExtractor.h"
#include "ClassLabel.h"
#include "ClassLabelHistogram.h"
#include "Classifier.h"
#include "ExtraTreeClassifier.h"
#include "SvmClassifier.h"
#include "PDF.h"
#include "DecisionNode.h"
#include "TerminalNode.h"

#include <Magick++.h>
#include <list>
#include <string>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <time.h>
#include <cmath>

using namespace std;
using namespace Magick;

#include "frimclaUtils.cpp"
#include "frimclaUtils2.cpp"

int main(int argc, char* argv[])
{
  // ***************************************
  // Initialisation / set default parameters
  // ***************************************
  
  ExtraTreeClassifier::ExtraTreeParams extraTreeParams;
  svm_parameter svmParams;
  PDF::PdfParams pdfParams;
  MainParams mainParams;
  
  if (true) {
    extraTreeParams.nbOfTrees = 10;                 // number of extra-trees inside classifier
    extraTreeParams.useCompareAtt = false;          // weather decision nodes compare attribute to threshold or to another attribute
    extraTreeParams.useSimpleScore = false;         // weather to use simple score or entropy-based score 
    extraTreeParams.useSoftThreshold = false;       // weather data is split hardly or to both sides if close to threshold
    extraTreeParams.scoreThreshold = 0.2;           // threshold score function must sattisfy
    extraTreeParams.nbScoreTries = 50;              // nb tries to pick attribute+thresold that satisfies score threshold
    extraTreeParams.pruningThreshold = 0.0;         // if maximum score achieved is lower that this threshold, subtree is pruned
    extraTreeParams.maxNbPrunedNodes = 0;           // in percent of total number of nodes, 0 => no pruning
    extraTreeParams.maxNbTerminalNodes = 0;         // 0 => no pruning, otherwise only used when maxNoPrunedNodes=0
    
    svmParams.svm_type = C_SVC;	    // available: C_SVC, NU_SVC, ONE_CLASS, EPSILON_SVR, NU_SVR
    svmParams.kernel_type = LINEAR; // available: LINEAR [u'*v], POLY [(gamma*u'*v + coef0)^degree], RBF[exp(-gamma*|u-v|^2)], SIGMOID [tanh(gamma*u'*v + coef0)]
    svmParams.degree = 5;          // degree in kernel function
    svmParams.gamma = 1;            // gamma in kernel function (default 1/k)
    svmParams.coef0 = 0;            // coef0 in kernel function (default 0)
    svmParams.nu = 0.5;             // parameter nu of nu-SVC, one-class SVM, and nu-SVR
    svmParams.cache_size = 500;     // in MB
    svmParams.C = 100;              // cost-parameter C for C_SVC, EPSILON_SVR and NU_SVR
    svmParams.eps = 1e-3;           // stopping criteria, usually use 0.00001 in nu-SVC, 0.001 in others
    svmParams.p = 0.1;              // for EPSILON_SVR
    svmParams.shrinking = 1;        // use the shrinking heuristics {0,1}
    svmParams.probability = 0;      // do probability estimates {0,1}
    svmParams.nr_weight = 0;        // for C_SVC
    svmParams.weight_label = NULL;  // for C_SVC
    svmParams.weight = NULL;        // for C_SVC

    pdfParams.initValue = 1;
    pdfParams.maxValue = 0;
    pdfParams.incMethod = PDF::imCube;
    
    char cwd[256];
    getcwd(cwd, 256);
    mainParams.currentDirectory = string(cwd) + "/";
    mainParams.classificationMethod = CM_EXTRA_TREE_SINGLE_ATT; //{CM_EXTRA_TREE_SINGLE_ATT, CM_EXTRA_TREE_COMPARE_ATT, CM_SVM}
    mainParams.nbOfTrainingWindowsTotal = 120000;  // number of feature vectors to extract for training in total
    mainParams.useSameNbTrWinPerClass = false;     // std: same amount per image. but if EER is important, this option might be useful
    mainParams.nbOfTestingWindowsPerImg = 100;     // number of feature vectors to extract from each image in testing stage
    mainParams.maxSubwindowSize = 100;             // maximum size of sampled subwindow in % of image size
    mainParams.minObjBgrRatio = 0.7;               // minimum percentage of object in training window (using groundtruth-masks)
    mainParams.siftCfgFile = "paramSIFT.txt";
    mainParams.masksPath = "masks/";
    mainParams.groundtruthImgExtension = ".jpg";
    mainParams.groundtruthTxtExtension = "_horses.groundtruth";
    mainParams.extMethod = FeatureExtractor::ColorHSL;
    mainParams.pdfIncAmount = 14;
    mainParams.pdfDecAmount = -10;
    mainParams.pdfIncParam1 = 10; // radius for cube, square
    mainParams.pdfIncParam2 = 0; // scale-radius for square
    mainParams.usePDFRadiusAdaption = false;
    mainParams.use2ndStageClassifier = CL2_NONE;
    mainParams.ImgFileExtensions.push_back(".jpg");
    mainParams.ImgFileExtensions.push_back(".bmp");
    mainParams.ImgFileExtensions.push_back(".tif");
    mainParams.ImgFileExtensions.push_back(".png");
    mainParams.ImgFileExtensions.push_back(".pgm");
    mainParams.nbDebugImages = 0;                      // number of output debug images per class
    mainParams.debugImageDirectory = "~/";
    mainParams.nbPDFImages = 0;                        // number of output debug images per class
    mainParams.PDFImageDirectory = "~/";
    mainParams.outputFile = "";
    mainParams.loadClassifierFile = "";
    mainParams.saveClassifierFile = "";
    mainParams.treeLeafesOutputFile = "";
    mainParams.saveFeatureVectors = false;
    mainParams.featureVecOutputDir = "";
    mainParams.readFeatureVectors = false;
    mainParams.featureVecInputDir = "";
    mainParams.doTreeWeightUpdate = false;
  }
  extern int CurDEBUGLEVEL;
  CurDEBUGLEVEL = 0;
  
  // *********************************
  // evaluate passed program arguments
  // *********************************
  vector<string> args;
  for (int i=1; i<argc; i++) {
    args.push_back(string(argv[i]));
  }
  string errorMsg = evaluateParams(args, &mainParams, &extraTreeParams, &svmParams, &pdfParams);
  if (errorMsg == "NICEEXIT")
    return 0;
  
  if ((errorMsg == "") && (mainParams.trainingFiles.empty()) && (mainParams.loadClassifierFile == "")) {
    errorMsg = "\nNo training files found";
  }
  if ((errorMsg == "") && (mainParams.classificationFiles.empty()) && (!mainParams.readFeatureVectors)) {
    errorMsg = "\nNo classification files found";
  }
  if (errorMsg != "") {
    cerr << endl << "EXITING!" << errorMsg << endl << "Run with \"--help\" for info about usage" << endl << endl;
    return 1;
  } //-end if paramError
  
  Classifier* classifier = 0;
  ExtraTreeClassifier *etclassifier = 0;
  Classifier* classifier2 = 0;
  unsigned int maxID = 0;
  vector<double> binariseThresholds;
  vector<double> normalizeMeans;
  vector<double> normalizeDeviations;
  time_t startwindowing = 0;
  time_t startwindowing2 = 0;
  time_t endwindowing = 0;
  time_t endwindowing2 = 0;
  time_t starttraining = 0;
  time_t starttraining2 = 0;
  time_t endtraining = 0;
  time_t endtraining2 = 0;
  
  // calculate classCount
  unsigned int classCount = 0;
  unsigned int maxClass = 0;
  list<ClassLabel> tmpclassLabelList;
  mainParams.trainingFileLabels.getListOfClassLabels(&tmpclassLabelList);
  for (list<ClassLabel>::iterator p=tmpclassLabelList.begin(); (p!=tmpclassLabelList.end()); ++p)  {
    maxClass = max(maxClass, (unsigned int)*p);
    classCount++;
  } // classCount will contain the real number of classes, not containing class "0"

  // adjust parameters, if minimal per-class-error wants to be achieved instead of total error
  if (mainParams.useSameNbTrWinPerClass) {
    svmParams.nr_weight = classCount;
    svmParams.weight_label = new int[classCount];
    svmParams.weight = new double[classCount];
    int i = 0;
    double sum = 0;
    for (list<ClassLabel>::iterator p=tmpclassLabelList.begin(); (p!=tmpclassLabelList.end()); ++p)  {
      ClassLabel currCL = *p;
      svmParams.weight_label[i] = currCL;
      svmParams.weight[i] = 1/mainParams.trainingFileLabels.getCountOfLabel(currCL);
      //svmParams.weight[i] = svmParams.weight[i] * svmParams.weight[i];
      sum += svmParams.weight[i];
      i++;
    }
    while (i>0) { //normalize sum of weights to 1 or svmParams.C
      i--;
      //svmParams.weight[i] = svmParams.weight[i] * svmParams.C / sum;
      svmParams.weight[i] = svmParams.weight[i] * 1 / sum;
    }
  }
    
  
  cout << endl;
  // ######################################################################################
  // ######################################################################################
  // ########################                                      ########################
  // ########################           CREATE CLASSIFIER          ########################
  // ########################                                      ########################
  // ######################################################################################
  // ######################################################################################
  
  // ######################################################
  //             LOADING CLASSIFIER FROM FILE
  // ######################################################
  
  if (mainParams.loadClassifierFile != "") {
    cout << endl << "========== loading classifier from file ==========" << endl;
    
    ifstream inFile (mainParams.loadClassifierFile.c_str());
    if (! inFile.eof() ) // read extraTreeParams
    {
      string s;
      getline(inFile,s);
      int tmpbool1;
      int tmpbool2;
      if (sscanf(s.c_str(), "extraTreeParams;%d;%d;%d;%lf;%d;%lf;%u;%u", 
                            &(extraTreeParams.nbOfTrees),
                            &tmpbool1,
                            &tmpbool2,
                            &(extraTreeParams.scoreThreshold),
                            &(extraTreeParams.nbScoreTries),
                            &(extraTreeParams.pruningThreshold),
                            &(extraTreeParams.maxNbPrunedNodes),
                            &(extraTreeParams.maxNbTerminalNodes)
                            ) != 8) {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
      extraTreeParams.useCompareAtt = (tmpbool1 > 0);
      extraTreeParams.useSimpleScore = (tmpbool2 > 0);
    } // !eof
    if (! inFile.eof() ) // read svmParams
    {
      string s;
      getline(inFile,s);
      if (sscanf(s.c_str(), "svmParams;%d;%d;%lf;%lf;%lf;%lf;%lf;%lf;%lf;%lf;%d;%d", 
                            &(svmParams.svm_type),
                            &(svmParams.kernel_type),
                            &(svmParams.degree),
                            &(svmParams.gamma),
                            &(svmParams.coef0),
                            &(svmParams.nu),
                            &(svmParams.cache_size),
                            &(svmParams.C),
                            &(svmParams.eps),
                            &(svmParams.p),
                            &(svmParams.shrinking),
                            &(svmParams.probability)
                            //&(svmParams.nr_weight),
                            //&(svmParams.weight_label),
                            //&(svmParams.weight)
                            ) != 12) {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
    } // !eof
    if (! inFile.eof() ) // read pdfParams
    {
      string s;
      getline(inFile,s);
      char str [256];
      if (sscanf(s.c_str(), "pdfParams;%u;%u;%s", 
                            &(pdfParams.initValue),
                            &(pdfParams.maxValue),
                            str
                            ) != 3) {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
      pdfParams.incMethod = PDF::asIncMethod(string(str));
    } // !eof
    if (! inFile.eof() ) // read mainParams
    {
      string s;
      getline(inFile,s);
      char str1 [256]; char str2 [256]; char str3 [256]; char str4 [256]; char str5 [256]; char str6 [256]; char str7 [256];
      int tmpbool;
      unsigned int ui1;
      mainParams.nbOfTrainingWindowsTotal = 0;
      mainParams.nbOfTrainingWindowsPerImg = 0;
      if (sscanf(s.c_str(), "mainParams;%[^;];%u;%u;%u;%d;%lf;%[^;];%[^;];%[^;];%[^;];%[^;];%d;%d;%lf;%lf;%d;%[^;]", 
                            str1,
                            &(mainParams.nbOfTrainingWindowsTotal),
                            &(mainParams.nbOfTrainingWindowsPerImg),
                            &(ui1),
                            &(mainParams.maxSubwindowSize),
                            &(mainParams.minObjBgrRatio),
                            str7,
                            str2,
                            str3,
                            str4,
                            str5,
                            &(mainParams.pdfIncAmount),
                            &(mainParams.pdfDecAmount),
                            &(mainParams.pdfIncParam1),
                            &(mainParams.pdfIncParam2),
                            &tmpbool,
                            str6
                            ) != 17) {
        cout << "Error reading from " << mainParams.loadClassifierFile << " in line " << endl << s << endl;
        return 1;
      } // scanf ok
      if (mainParams.nbOfTestingWindowsPerImg == 100) // only overwrite of user didn't specify a different value
        mainParams.nbOfTestingWindowsPerImg = ui1;
      mainParams.classificationMethod = asClassificationMethod(string(str1));
      mainParams.siftCfgFile = string(str7);
      mainParams.masksPath = string(str2);
      mainParams.groundtruthImgExtension = string(str3);
      mainParams.groundtruthTxtExtension = string(str4);
      mainParams.extMethod = FeatureExtractor::asExtractionMethod(string(str5));
      mainParams.usePDFRadiusAdaption = (tmpbool > 0);
      mainParams.use2ndStageClassifier = asClassifierStage2(string(str6));
    } // !eof
    if (! inFile.eof() ) // read current values
    {
      string s;
      getline(inFile,s);
          
      if (sscanf(s.c_str(), "currValues;%u;%u;%u;%lu;%lu;%lu;%lu;%lu;%lu;%lu;%lu", 
                            &(classCount),
                            &(maxClass),
                            &(maxID),
                            &(startwindowing),
                            &(startwindowing2),
                            &(endwindowing),
                            &(endwindowing2),
                            &(starttraining),
                            &(starttraining2),
                            &(endtraining),
                            &(endtraining2)
                            ) != 11) {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
    } // !eof
    if (! inFile.eof() ) // read binariseThresholds
    {
      string s;
      getline(inFile,s);
      if (s.find("binariseThresholds:", 0) == 0) {
        s.erase(0,19);
        binariseThresholds.clear();
        istringstream ss(s);
        double value;
        while (!ss.eof()) {
          ss >> value;
          if (ss.fail())
            break;
          else
            binariseThresholds.push_back(value);
        }
      } else {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
    } // !eof
    if (! inFile.eof() ) // read normalizeMeans
    {
      string s;
      getline(inFile,s);
      if (s.find("normalizeMeans:", 0) == 0) {
        s.erase(0,15);
        normalizeMeans.clear();
        istringstream ss(s);
        double value;
        while (!ss.eof()) {
          ss >> value;
          if (ss.fail())
            break;
          else
            normalizeMeans.push_back(value);
        }
      } else {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
    } // !eof
    if (! inFile.eof() ) // read normalizeDeviations
    {
      string s;
      getline(inFile,s);
      if (s.find("normalizeDeviations:", 0) == 0) {
        s.erase(0,20);
        normalizeDeviations.clear();
        istringstream ss(s);
        double value;
        while (!ss.eof()) {
          ss >> value;
          if (ss.fail())
            break;
          else
            normalizeDeviations.push_back(value);
        }
      } else {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
    } // !eof

    if (! inFile.eof() ) // read classifier 1
    {
      string s;
      getline(inFile,s);
      char classifierfn [256];
      if (sscanf(s.c_str(), "classifier1=%s", classifierfn) != 1) {
        cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
        return 1;
      } // scanf ok
      if (fileExists(classifierfn)) {
        ifstream tempInFile (classifierfn);
        s = "";
        if (! tempInFile.eof() )
          getline(tempInFile,s);
        tempInFile.close();
        if (s.find("ExtraTreeClassifier") != string::npos) {
          etclassifier = new ExtraTreeClassifier(string(classifierfn));
          classifier = etclassifier;
        } else if (s.find("SVMClassifier") != string::npos) {
          classifier = new SvmClassifier(classifierfn);
        } else {
          cerr << "Error reading from " << classifierfn <<". No classifier detected!" << endl;
          return 1;
        }
        if (classifier == 0) {
          cerr << "Error. No classifier found!" << endl;
          return 1;
        }
      } // classifier 2 file exists
      // otherwise just ignore
    }
    
    if (mainParams.use2ndStageClassifier != CL2_NONE) {
      if (! inFile.eof() ) // read classifier 2
      {
        string s;
        getline(inFile,s);
        char classifierfn [256];
        if (sscanf(s.c_str(), "classifier2=%s", classifierfn) != 1) {
          cerr << "Error reading from " << mainParams.loadClassifierFile << " in line " << s << endl;
          return 1;
        } // scanf ok
        if (fileExists(classifierfn)) {
          ifstream tempInFile (classifierfn);
          s = "";
          if (! tempInFile.eof() )
            getline(tempInFile,s);
          tempInFile.close();
          if (s.find("ExtraTreeClassifier") != string::npos) {
            classifier2 = new ExtraTreeClassifier(string(classifierfn));
          } else if (s.find("SVMClassifier") != string::npos) {
            classifier2 = new SvmClassifier(classifierfn);
          } else {
            cerr << "Error reading from " << classifierfn <<". No classifier detected!" << endl;
            return 1;
          }
          if (classifier2 == 0) {
            cerr << "Error. Second classifier not found!" << endl;
            return 1;
          }
        } // file exists
      } // !eof
    } // use2ndStageClassifier
      
  }
  
  
  // ######################################################
  //                TRAINING OF CLASSIFIER 1
  // ######################################################
  
  if (classifier == 0) {
    cout << endl << "========== training of classifier ==========" << endl;
    
    randomInit();
    // ********************
    // extract the features
    // ********************
    list<FeatureVector*> featureList;
    if (mainParams.readFeatureVectors) {
      cout << "loading features from file..." << flush;
      readFileFeatureVectors ("trainingfeatures", mainParams.featureVecInputDir, featureList);
      cout << endl;
    } 
    if (featureList.empty()) {
      mainParams.nbOfTrainingWindowsPerImg = max(1,(int)(mainParams.nbOfTrainingWindowsTotal/mainParams.trainingFiles.size()));
      cout << "extracting features from " << mainParams.trainingFiles.size() << " images (" << mainParams.nbOfTrainingWindowsPerImg << " windows per image)..." << flush;
      startwindowing = time(0);
      CurDEBUGLEVEL = 0;
      int curDebugImage = 1;
      ClassLabel oldLabel = -1;
      // for each training file do:
      for (vector<TrainingFile>::iterator p=mainParams.trainingFiles.begin(); p!=mainParams.trainingFiles.end(); ++p)  {
        TrainingFile currFile = *p;
        //cout << endl << "  processing image " << currFile.fileName << flush;
        
        //start creating debug images, when classLabel changes
        if (oldLabel != currFile.classLabel)
          curDebugImage=1;
        oldLabel = currFile.classLabel;
        
        list<FeatureVector*> filefeatureList;
        filefeatureList.clear();  // items will be transfered into featureList and deleted after training. so only clear list
        
        //read image and extract features
        Magick::Image img;
        try {
          img.read(currFile.fileName.c_str());
        } catch( Exception &error_ ) { 
          cerr << "Caught exception while reading image: " << error_.what() << endl; 
          continue;
        }
        unsigned int maxScale = (unsigned int)(((double)min(img.columns(),img.rows()) * mainParams.maxSubwindowSize / 100));
        PDF* pdf = new PDF(img.columns(), img.rows(), WINDOW_SIZE, maxScale, pdfParams, currFile.groundtruthTxtFile);
        FeatureExtractor* fExtractor = new FeatureExtractor(img, currFile.fileName, pdf, mainParams.extMethod, mainParams.siftCfgFile, currFile.groundtruthImgFile);
        int numb = mainParams.nbOfTrainingWindowsPerImg;
        if (mainParams.useSameNbTrWinPerClass)
          numb = mainParams.nbOfTrainingWindowsTotal/(classCount*mainParams.trainingFileLabels.getCountOfLabel(currFile.classLabel));
        fExtractor->extractFeatures(numb, &filefeatureList, mainParams.minObjBgrRatio);
        delete fExtractor;
        delete pdf;
        attachClassLabel(&filefeatureList, &featureList, currFile.classLabel);
        if (mainParams.nbDebugImages >= curDebugImage)
          createDebugImage(currFile.fileName, mainParams.debugImageDirectory, &filefeatureList, 0, 0, 0, mainParams.extMethod);
        curDebugImage++;
        cout << "." << flush;
      } //-end for each training file
      cout << endl;
      endwindowing = time(0);
    }
    if (mainParams.saveFeatureVectors) {
      startwindowing = time(0);
      cout << "saving features to file..." << flush;
      saveFileFeatureVectors("trainingfeatures", featureList, mainParams.featureVecOutputDir);
      cout << endl;
      endwindowing = time(0);
    }
    
    // ********************
    // train the classifier
    // ********************
    cout << "training the classifier with "<<featureList.size()<<" features...";
    CurDEBUGLEVEL = 1;
    starttraining = time(0);
    if ((mainParams.classificationMethod == CM_EXTRA_TREE_SINGLE_ATT) 
     || (mainParams.classificationMethod == CM_EXTRA_TREE_COMPARE_ATT)
     || (mainParams.classificationMethod == CM_EXTRA_TREE_SOFT_THRESHOLD)) {
      etclassifier = new ExtraTreeClassifier(featureList, extraTreeParams);
/*      if (mainParams.treeLeafesOutputFile)
        etclassifier->visualizeLeafNodes(mainParams.treeLeafesOutputFile);*/
      classifier = etclassifier;
    }
    if ((mainParams.classificationMethod == CM_SVM)) {
      SvmClassifier *svmclassifier;
      svmclassifier = new SvmClassifier(&featureList, &svmParams);
      classifier = svmclassifier;
    }
    endtraining = time(0);
    //cout << DecisionNode::totalDecisionNodeCount << " DecisionNodes constructed" << endl;
    //cout << TerminalNode::totalTerminalNodeCount << " TerminalNodes constructed" << endl;
    
    // ***********************
    // delete the feature list
    // ***********************
    deleteFeatureVectors(&featureList);
        
  } //-end training classifier 1
  
  
  // ######################################################
  //                TRAINING of Classifier 2
  // ######################################################
  
  if ((mainParams.use2ndStageClassifier != CL2_NONE) && (etclassifier != 0) && (classifier2 == 0)) {
    cout << endl << endl << "========== training of 2nd stage classifier ==========" << endl;
    
    CurDEBUGLEVEL = 0;
    startwindowing2 = time(0);
    
    // ********************
    // extract the features
    // ********************
    list<FeatureVector*> featureList;
    ofstream filelist;
    ofstream filelistlabels;
    if (mainParams.saveFeatureVectors) {
      string list1name = mainParams.featureVecOutputDir + "trainingfilelist.txt";
      string list2name = mainParams.featureVecOutputDir + "trainingfilelabels.txt";
      filelist.open(list1name.c_str(), ios::out);
      filelistlabels.open(list2name.c_str(), ios::out);
    }
    maxID = TerminalNode::getMaxID();
    cout << "extracting features from " << mainParams.trainingFiles.size() << " images (" << mainParams.nbOfTestingWindowsPerImg << " windows per image)..." << flush;
    int curPDFImage = 1;
    int curDebugImage = 1;
    ClassLabel oldLabel = -1;
    for(vector<TrainingFile>::iterator p=mainParams.trainingFiles.begin(); p!=mainParams.trainingFiles.end(); ++p)  {
      cout << "." << flush;
      TrainingFile currFile = *p;
      if (mainParams.saveFeatureVectors) {
        filelist << mainParams.featureVecOutputDir << extractFileName(currFile.fileName) << ".desc" << endl;
        filelistlabels << currFile.classLabel << endl;
      }
      
      //cout << endl << currFile.fileName << "..." << flush;
      ClassLabelHistogram* totalVotes = new ClassLabelHistogram();
      ClassLabelHistogram* windowVotes = new ClassLabelHistogram();
      list<TerminalNode*> tnList; tnList.clear();
      
      if (oldLabel != currFile.classLabel) {
        curPDFImage=1;
        curDebugImage=1;
      }
      oldLabel = currFile.classLabel;
      
      classifyImage(classifier, etclassifier, currFile.fileName, 
                    (mainParams.nbDebugImages >= curDebugImage), (mainParams.nbPDFImages >= curPDFImage), mainParams, pdfParams,
                    totalVotes, windowVotes, &tnList);
			// totalVotes contains weightes sum of all votes, windowVotes contains #subwindows votes unweighted
      ClassLabel classifiedLabel = totalVotes->getRealLabelWithMaxWeight(); //most total votes
      //ClassLabel classifiedLabel = totalVotes->getRealLabelWithMaxOccurance(); //most total votes
      //ClassLabel classifiedLabel = windowVotes->getRealLabelWithMaxOccurance(); //most subwindow-based votes
      
      featureList.push_back(createFeatureVector(&tnList, mainParams.use2ndStageClassifier, maxID, currFile.classLabel, classifiedLabel));
      
      delete windowVotes;
      delete totalVotes;
      
      curPDFImage++;
      curDebugImage++;
    } // for each file
    
    endwindowing2 = time(0);
    if (mainParams.saveFeatureVectors) {
      filelist.close();
      filelistlabels.close();
    }
  
    // ********************************
    // binarise /normalize feature list
    // ********************************

    if (mainParams.use2ndStageClassifier == CL2_ENTROPY_PURE_BINARY) {
      cout << endl << "binarising features..." << flush;
      calcBinarisationThresholds(featureList, binariseThresholds, classifier->classLabelList);
      binarise(featureList, binariseThresholds);
    }
    if (mainParams.use2ndStageClassifier == CL2_PURE_NORM_NODE_COUNT) {
      cout << endl << "normalizing features..." << flush;
      calcNormalizationParameters(featureList, normalizeMeans, normalizeDeviations);
      normalize(featureList, normalizeMeans, normalizeDeviations);
    }

    /*      cout << endl << endl << "1st Feature: ";
      FeatureVector *fv2 = *(featureList.begin());
      int dimcount2 = fv2->getSize();
      for(int dim=0; dim<dimcount2; dim++)  {
        cout << fv2->getElement(dim) << "  ";
      }
      cout << endl;*/
  
    // ********************
    // train the classifier
    // ********************
    starttraining2 = time(0);
		//FeatureVector::writeIntoStream(featureList, cout, cout, 1);
    cout << endl << "training the classifier..." << flush;
    SvmClassifier *svmclassifier = new SvmClassifier(&featureList, &svmParams);
    deleteFeatureVectors(&featureList);
    classifier2 = svmclassifier;
    endtraining2 = time(0);
    
    
		// ********************
    // evaluate classifier
    // ********************
    // update weights of terminal nodes of decision trees
    if (mainParams.doTreeWeightUpdate) {
      unsigned int wcount = classCount*(classCount-1)/2;
      double** w = new double* [wcount]; // w[classCount(classCount-1)/2][DimensionNumber]
      // allocate memory
      for (unsigned int i=0; i<wcount; i++) {
        w[i] = new double [maxID]; // initialisation of values is done in the next call
      } 
      // get the weights from svm
      svmclassifier->getWeights(w, (int)maxID);

			
			// update the weights of the terminal nodes
			cout << setiosflags(ios::fixed) << setw(2) << setprecision(3);
			double maxweight = 0; // save the maximum to be able to normalize the weights in a second loop
      double* csum = new double [classCount]; // temporary buffer for the weights for each class
			list<TerminalNode*>* tnlist = etclassifier->getTnList();
			unsigned int dim = 0;
			for(list<TerminalNode*>::iterator p=tnlist->begin(); p!=tnlist->end() && dim<maxID; ++p)
			{
/*				cout << endl << "weights for dim " << dim << ":\t";
				for (unsigned int i=0; i<wcount; i++)
					cout << w[i][dim] << "\t";*/
				
				// initialize buffer for weights
	      for (unsigned int i=0; i<classCount; i++)
					csum[i] = 0;
					
				// determine the class label and which index the class label corresponds to
				TerminalNode* tn = *p;
				ClassLabel cl = tn->classLabel;
				unsigned cn = 0;
				for(list<ClassLabel>::iterator q=svmclassifier->classLabelList.begin(); q!=svmclassifier->classLabelList.end(); ++q) {
					if (*q == cl)
						break;
					cn++;
				}
				
				// now: tn = current terminal node + dim = its corresponding index to access w[][dim]
				//      cl = the nodes class label + cn  = the class labels list index (0..classCount-1)
				//                                 + classCount = the number of classes (2,..)
				int currIndex = 0;
				for(unsigned i=0;i<classCount-1;i++)       // for each classifier for class i
					for(unsigned int j=i+1;j<classCount;j++) //                 against class j
					{
						csum[i] += w[currIndex][dim];
						csum[j] -= w[currIndex][dim];
						currIndex++;
					}
				
				//cout << "\t calculated weights for CL " << cl << ": ";
				double max1st = 0;
				double max2nd = 0;
				unsigned int maxindex = 0;
				for (unsigned int i=0; i<classCount; i++) {
					csum[i] /= (double)(classCount-1);
					if (csum[i] > max1st) {
						max2nd = max1st;
						max1st = csum[i];
						maxindex = i;
					}
					//cout << "\t" << csum[i];
				}
				// get the class label corresponding to the maximum index
				list<ClassLabel>::iterator q=svmclassifier->classLabelList.begin();
				for(unsigned int i=0; i<maxindex; i++) q++;
				cl = *q;
				//cout << "\t final CL: " << cl << " with weight " << max1st-max2nd;
				
				// update the terminal node
				tn->weight = max1st-max2nd;
				tn->classLabel = cl;
				//tn->weight = 1.0;
				maxweight = max(maxweight, tn->weight);
				
				dim++;
			}
			// normalize weights
			for(list<TerminalNode*>::iterator p=tnlist->begin(); p!=tnlist->end(); ++p)
				(*p)->weight = (*p)->weight / maxweight;
			
/*			// summarize weights of the different SVMs
      double wmax = 0; //maximum of the summarized weights
      for (unsigned int dim=0; dim<maxID; dim++) {
        double cmax = 0; // maximum of the weights of the SVMs for one specific dimension
        for (unsigned int i=0; i<wcount; i++)
          cmax = max(cmax, abs(w[i][dim]));
        w[0][dim] = cmax; // the weight of a dimension is the maximum of the abs(weights) of all SVMs for this dimension
        wmax = max(wmax, cmax);
      }
      // normalize
      for (unsigned int dim=0; dim<maxID; dim++) {
        w[0][dim] = w[0][dim] / wmax;
        //cout << endl << w[0][dim];
      }
      // update the weights of the terminal nodes
      list<TerminalNode*>* tnlist = etclassifier->getTnList();
      for(list<TerminalNode*>::iterator p=tnlist->begin(); p!=tnlist->end(); ++p)
      {
        TerminalNode* tn = *p;
        tn->weight = w[0][tn->getID()];
      }*/
      
      // free memory
			delete [] csum;
      for (unsigned int i=0; i<wcount; i++) {
        delete [] w[i];
      }
      delete [] w; // w[classCount(classCount-1)/2][DimensionNumber]
    } //-end update weights of terminal nodes of decision trees
  
  } // using 2nd stage classifier
  
    
  // ######################################################
  //                SAVING CLASSIFIER TO FILE
  // ######################################################
    
  if (mainParams.saveClassifierFile != "") {
    
    cout << endl << "========== saving classifier to file ==========" << endl;
    ofstream outfile (mainParams.saveClassifierFile.c_str(), ios::out | ios::trunc);
    
    outfile << "extraTreeParams";
    outfile << ";" << extraTreeParams.nbOfTrees;          //int
    outfile << ";" << extraTreeParams.useCompareAtt;      //bool
    outfile << ";" << extraTreeParams.useSimpleScore;     //bool
    outfile << ";" << extraTreeParams.scoreThreshold;     //double
    outfile << ";" << extraTreeParams.nbScoreTries;       //int
    outfile << ";" << extraTreeParams.pruningThreshold;   //double
    outfile << ";" << extraTreeParams.maxNbPrunedNodes;   //unsigned int
    outfile << ";" << extraTreeParams.maxNbTerminalNodes; //unsigned int
    outfile << endl;
    
    outfile << "svmParams";
    outfile << ";" << svmParams.svm_type;     //int
    outfile << ";" << svmParams.kernel_type;  //int
    outfile << ";" << svmParams.degree;       //double
    outfile << ";" << svmParams.gamma;        //double
    outfile << ";" << svmParams.coef0;        //double
    outfile << ";" << svmParams.nu;           //double
    outfile << ";" << svmParams.cache_size;   //double
    outfile << ";" << svmParams.C;            //double
    outfile << ";" << svmParams.eps;          //double
    outfile << ";" << svmParams.p;            //double
    outfile << ";" << svmParams.shrinking;    //int
    outfile << ";" << svmParams.probability;  //int
    //outfile << ";" << svmParams.nr_weight;    //int = 0
    //outfile << ";" << svmParams.weight_label; //int* = NULL
    //outfile << ";" << svmParams.weight;       //double* = NULL
    outfile << endl;
    
    outfile << "pdfParams";
    outfile << ";" << pdfParams.initValue;               //unsigned int
    outfile << ";" << pdfParams.maxValue;                //unsigned int
    outfile << ";" << PDF::asText(pdfParams.incMethod);  //IncMethod
    outfile << endl;
    
    outfile << "mainParams";
    //outfile << ";" << mainParams.currentDirectory;             //string
    outfile << ";" << asText(mainParams.classificationMethod); //ClassificationMethod
    outfile << ";" << mainParams.nbOfTrainingWindowsTotal;     //unsigned int  <- Training already over, so save info for summary
    outfile << ";" << mainParams.nbOfTrainingWindowsPerImg;    //unsigned int  <- Training already over, so save info for summary
    outfile << ";" << mainParams.nbOfTestingWindowsPerImg;     //unsigned int
    outfile << ";" << mainParams.maxSubwindowSize;             //int
    outfile << ";" << mainParams.minObjBgrRatio;               //double
    outfile << ";" << mainParams.siftCfgFile;                  //string
    outfile << ";" << mainParams.masksPath;                    //string
    outfile << ";" << mainParams.groundtruthImgExtension;      //string
    outfile << ";" << mainParams.groundtruthTxtExtension;      //string
    outfile << ";" << FeatureExtractor::asText(mainParams.extMethod); //FeatureExtractor::ExtractionMethod
    outfile << ";" << mainParams.pdfIncAmount;                 //int
    outfile << ";" << mainParams.pdfDecAmount;                 //int
    outfile << ";" << mainParams.pdfIncParam1;                 //double
    outfile << ";" << mainParams.pdfIncParam2;                 //double
    outfile << ";" << mainParams.usePDFRadiusAdaption;         //bool
    outfile << ";" << asText(mainParams.use2ndStageClassifier);//ClassifierStage2
    //outfile << ";" << mainParams.ImgFileExtensions;            //list<string>
    //outfile << ";" << mainParams.nbDebugImages;                //int
    //outfile << ";" << mainParams.debugImageDirectory;          //string
    //outfile << ";" << mainParams.nbPDFImages;                  //int
    //outfile << ";" << mainParams.PDFImageDirectory;            //string
    //outfile << ";" << mainParams.outputFile;                   //string
    //outfile << ";" << mainParams.loadClassifierFile;           //string
    //outfile << ";" << mainParams.saveClassifierFile;           //string
    //outfile << ";" << mainParams.trainingFiles;                //list<TrainingFile>
    //outfile << ";" << mainParams.classificationFiles;          //list<ClassificationFile>
    //outfile << ";" << mainParams.treeLeafesOutputFile;         //string
    //outfile << ";" << mainParams.saveFeatureVectors;           //bool
    //outfile << ";" << mainParams.featureVecOutputDir;          //string
    //outfile << ";" << mainParams.readFeatureVectors;           //bool
    //outfile << ";" << mainParams.featureVecInputDir;           //string
    outfile << endl;

    outfile << "currValues";
    outfile << ";" << classCount;      //unsigned int 
    outfile << ";" << maxClass;        //unsigned int 
    outfile << ";" << maxID;           //unsigned int
    outfile << ";" << startwindowing;  //time_t
    outfile << ";" << startwindowing2; //time_t
    outfile << ";" << endwindowing;    //time_t
    outfile << ";" << endwindowing2;   //time_t
    outfile << ";" << starttraining;   //time_t
    outfile << ";" << starttraining2;  //time_t
    outfile << ";" << endtraining;     //time_t
    outfile << ";" << endtraining2;    //time_t
    outfile << endl;
    outfile << "binariseThresholds:";
    for (vector<double>::iterator p=binariseThresholds.begin(); p!=binariseThresholds.end(); p++) {
      outfile << " " << *p;
    }
    outfile << endl;
    outfile << "normalizeMeans:";
    for (vector<double>::iterator p=normalizeMeans.begin(); p!=normalizeMeans.end(); p++) {
      outfile << " " << *p;
    }
    outfile << endl;
    outfile << "normalizeDeviations:";
    for (vector<double>::iterator p=normalizeDeviations.begin(); p!=normalizeDeviations.end(); p++) {
      outfile << " " << *p;
    }
    outfile << endl;
    
    if (classifier != 0) {
      string filename = mainParams.saveClassifierFile;
      filename.append(".classifier1");
      classifier->writeToFile(filename);
      outfile << "classifier1=" << filename << endl;
    }
    if (classifier2 != 0) {
      string filename = mainParams.saveClassifierFile;
      filename.append(".classifier2");
      classifier2->writeToFile(filename);
      outfile << "classifier2=" << filename << endl;
    }
      
    outfile.close();
  }
  
  
  
  // ######################################################################################
  // ######################################################################################
  // ########################                                      ########################
  // ########################           USE CLASSIFIER             ########################
  // ########################                                      ########################
  // ######################################################################################
  // ######################################################################################
  
  cout << endl << "========== classifying " << mainParams.classificationFiles.size() << " images ==========" << endl; 
  
  ofstream outFile;
  if (mainParams.outputFile != "") {
    outFile.open(mainParams.outputFile.c_str(), ios::out);
  }

  unsigned int nbCorrectlyClassified = 0;
  unsigned int nbMisclassified = 0;
  unsigned int nbFiles = mainParams.classificationFiles.size();
  answer *answers1 = new answer[nbFiles];
  answer *answers2 = new answer[nbFiles];
  double tn1 = 0; //!< true negatives
  double fn1 = 0; //!< false negatives
  double tp1 = 0; //!< true positives
  double fp1 = 0; //!< false positives
  double tn2 = 0; //!< true negatives
  double fn2 = 0; //!< false negatives
  double tp2 = 0; //!< true positives
  double fp2 = 0; //!< false positives
  ClassLabel negativeClass = *(classifier->classLabelList.begin());
  double EqualErrorRate1 = -1.0;
  double tprate1 = 0.0;
  double EqualErrorRate2 = -1.0;
  double tprate2 = 0.0;
      
  // ***** creating confusion matrix *****
  unsigned int** confusionMatrix = new unsigned int* [maxClass+1];
  for (unsigned int i=0; i<=maxClass; i++) {
    confusionMatrix[i] = new unsigned int [maxClass+1];
    for (unsigned int j=0; j<=maxClass; j++)
      confusionMatrix[i][j] = 0;
  }
  
  time_t startclassification = time(0);
  int curDebugImage = 1;
  int curPDFImage = 1;
  ClassLabel oldLabel = -1;
  
  ofstream filelist;
  ofstream filelistlabels;
  if (mainParams.saveFeatureVectors) {
    string list1name = mainParams.featureVecOutputDir + "testingfilelist.txt";
    string list2name = mainParams.featureVecOutputDir + "testingfilelabels.txt";
    filelist.open(list1name.c_str(), ios::out);
    filelistlabels.open(list2name.c_str(), ios::out);
  }
  
  // **************
  // for each file
  // **************
  list<FeatureVector*> featureList; featureList.clear();
  unsigned int fileNumber = 0;
  for(vector<ClassificationFile>::iterator p=mainParams.classificationFiles.begin(); p!=mainParams.classificationFiles.end(); ++p)  {
    fileNumber++;
    cout << "." << flush;
    ClassificationFile currFile = *p;
    CurDEBUGLEVEL = 0;
    
    //cout << endl << currFile.fileName << "..." << flush;
    if (mainParams.saveFeatureVectors) {
      filelist << mainParams.featureVecOutputDir << extractFileName(currFile.fileName) << ".desc" << endl;
      filelistlabels << currFile.classLabel << endl;
    }
    
    ClassLabelHistogram* totalVotes = new ClassLabelHistogram();
    ClassLabelHistogram* windowVotes = new ClassLabelHistogram();
    list<TerminalNode*> tnList; tnList.clear();
    
    if (oldLabel != currFile.classLabel) {
      curPDFImage=1;
      curDebugImage=1;
    }
    oldLabel = currFile.classLabel;
    
    classifyImage(classifier, etclassifier, currFile.fileName, 
                  (mainParams.nbDebugImages >= curDebugImage), (mainParams.nbPDFImages >= curPDFImage), mainParams, pdfParams, 
                  totalVotes, windowVotes, &tnList);
    ClassLabel classifiedLabel = totalVotes->getRealLabelWithMaxWeight(); //most total votes
    //ClassLabel classifiedLabel = totalVotes->getRealLabelWithMaxOccurance(); //most total votes
    //ClassLabel classifiedLabel = windowVotes->getRealLabelWithMaxOccurance(); //most subwindow-based votes
    if (classifier2 != 0) {
      featureList.push_back(createFeatureVector(&tnList, mainParams.use2ndStageClassifier, maxID, currFile.classLabel, classifiedLabel));
      if (mainParams.use2ndStageClassifier == CL2_ENTROPY_PURE_BINARY)
        binarise(featureList, binariseThresholds);
      if (mainParams.use2ndStageClassifier == CL2_PURE_NORM_NODE_COUNT)
        normalize(featureList, normalizeMeans, normalizeDeviations);
      classifiedLabel = classifier2->classify(&featureList);
      deleteFeatureVectors(&featureList);
    }
    
    curPDFImage++;
    curDebugImage++;
          
    if (currFile.classLabel != 0)  {
      if (currFile.classLabel != classifiedLabel)
        nbMisclassified++;
      else
        nbCorrectlyClassified++;
    }
    confusionMatrix[currFile.classLabel][classifiedLabel] += 1;
    
    // Create Statistics for ROC-Curve. Only possible in 2-class-case
    if (classCount == 2) { 
      if (currFile.classLabel == negativeClass) {
        answers1[fileNumber-1].label = -1;
        tn1++;
      } else {
        answers1[fileNumber-1].label = +1;
        fn1++;
      }
      answers1[fileNumber-1].value = classifier->getLastConfidenceValue();
      
      if (classifier2 != 0) {
        if (currFile.classLabel == negativeClass) {
          answers2[fileNumber-1].label = -1;
          tn2++;
        } else {
          answers2[fileNumber-1].label = +1;
          fn2++;
        }
        answers2[fileNumber-1].value = classifier2->getLastConfidenceValue();
      }
    }
    
    // print info in output file
    if (mainParams.outputFile != "") {
      outFile << "\"" << currFile.fileName << "\"\t" << classifiedLabel;
      outFile << "\t" << totalVotes->getCountOfLabel(0);
      for (list<ClassLabel>::iterator p=classifier->classLabelList.begin(); (p!=classifier->classLabelList.end()); ++p)  {
        outFile << "\t" << totalVotes->getCountOfLabel(*p);
      }
      if (classCount == 2) {
        outFile << "\t" << classifier->getLastConfidenceValue();
        if (classifier2 != 0)
          outFile << "\t" << classifier2->getLastConfidenceValue();
      }
    }
    outFile << endl;
    
    delete windowVotes;
    delete totalVotes;
  } // for each file
  cout << endl;
  time_t endclassification = time(0);
  if (mainParams.saveFeatureVectors) {
    filelist.close();
    filelistlabels.close();
  }
  if ((etclassifier != 0) && (mainParams.treeLeafesOutputFile != ""))
    etclassifier->visualizeLeafNodes(mainParams.treeLeafesOutputFile);

  // Do ROC-Plot
  if (mainParams.outputFile != "") {
    if (classCount == 2) {
      createROCPlot(string(mainParams.outputFile+"_ROC"), &tn1, &fn1, &tp1, &fp1, answers1, nbFiles, &EqualErrorRate1, &tprate1);
      if (classifier2 != 0) {
        createROCPlot(string(mainParams.outputFile+"_ROC2"), &tn2, &fn2, &tp2, &fp2, answers2, nbFiles, &EqualErrorRate2, &tprate2);
      } 
    } 
  } //-end Do ROC-Plot
  delete [] answers1;
  delete [] answers2;
  
  // ***********************
  //  print Summary
  // ***********************
  int diffwindowing = (endwindowing-startwindowing);
  int difftraining = (endtraining-starttraining);
  int diffwindowing2 = (endwindowing2-startwindowing2);
  int difftraining2 = (endtraining2-starttraining2);
  int diffclassification = (endclassification-startclassification);
  printSummary(&cout, mainParams, extraTreeParams, pdfParams, diffwindowing, difftraining, diffwindowing2, difftraining2, diffclassification, &(classifier->classLabelList),
                confusionMatrix, nbCorrectlyClassified, nbMisclassified, EqualErrorRate1, tprate1, EqualErrorRate2, tprate2);
  if (mainParams.outputFile != "")
    printSummary(&outFile, mainParams, extraTreeParams, pdfParams, diffwindowing, difftraining, diffwindowing2, difftraining2, diffclassification, &(classifier->classLabelList),
                confusionMatrix, nbCorrectlyClassified, nbMisclassified, EqualErrorRate1, tprate1, EqualErrorRate2, tprate2);
  
  for (unsigned int i=0; i<maxClass+1; i++)
    delete [] confusionMatrix[i];
  delete [] confusionMatrix;

  
  // ***********************
  // deinitialise / free memory
  // ***********************
  CurDEBUGLEVEL = 0;
  if (classifier2 != 0)
    delete classifier2;
  delete classifier;
  svm_destroy_param(&svmParams);
  if (mainParams.outputFile != "") {
    outFile.close();
  }

      
  return 0;
}

///

