#include <Magick++.h>
#include "FMUtils.h"
#include <list>
#include <vector>
#include <string>
#include <fstream>
#include <iostream>
#include <sstream>
#include <time.h>
#include <cmath>

#include "FeatureVector.h"
#include "ClassLabel.h"
#include "ClassLabelHistogram.h"
#include "Classifier.h"
#include "SvmClassifier.h"
#include "libsvm/svm.h"

using namespace std;
using namespace Magick;


//#include "frimclaUtils.cpp"
//#include "frimclaUtils2.cpp"

/***************************************************************************
   Main program:
   - read image
   - select random window
   - save window to file
 ***************************************************************************/
int main(int argc, char* argv[])
{
	
  svm_parameter svmParams;
    svmParams.svm_type = C_SVC;
    svmParams.kernel_type = LINEAR;
    svmParams.degree = 15;         
    svmParams.gamma = 1;           
    svmParams.coef0 = 0;           
    svmParams.nu = 0.5;            
    svmParams.cache_size = 500;    
    svmParams.C = 100;             
    svmParams.eps = 1e-3;          
    svmParams.p = 0.1;             
    svmParams.shrinking = 1;       
    svmParams.probability = 0;     
    svmParams.nr_weight = 0;       
    svmParams.weight_label = NULL; 
    svmParams.weight = NULL;      
	SvmClassifier *svmclassifier;
	list<FeatureVector*> featureList;
		FeatureVector* a;
		a = new FeatureVector();
			a->classLabel = 1;
			a->addElement(0); a->addElement(2);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 1;
			a->addElement(0); a->addElement(3);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 1;
			a->addElement(1); a->addElement(1);
  	  featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 1;
			a->addElement(1); a->addElement(2);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 1;
			a->addElement(1); a->addElement(3);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 2;
			a->addElement(3); a->addElement(0);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 2;
			a->addElement(4); a->addElement(0);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 2;
			a->addElement(5); a->addElement(0);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 2;
			a->addElement(3); a->addElement(1);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 2;
			a->addElement(4); a->addElement(1);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(3); a->addElement(-3);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(3); a->addElement(-4);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(4); a->addElement(-3);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(4); a->addElement(-4);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(4); a->addElement(-5);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(5); a->addElement(-4);
    	featureList.push_back(a);
		a = new FeatureVector();
			a->classLabel = 3;
			a->addElement(2); a->addElement(-5);
    	featureList.push_back(a);
	svmclassifier = new SvmClassifier(&featureList, &svmParams);
		unsigned int classCount = 3;
		unsigned int wcount = classCount*(classCount-1)/2;
		double** w = new double* [wcount]; // w[classCount(classCount-1)/2][DimensionNumber]
		for (unsigned int i=0; i<wcount; i++) {
			w[i] = new double [2]; // initialisation of values is done in the next call
		} 
		svmclassifier->getWeights(w, 2);
		for (unsigned int dim=0; dim<2; dim++) {
			cout << endl << "weights for dimension " << dim << ":    ";
			for (unsigned int i=0; i<wcount; i++)
				cout << w[i][dim] << "\t";
		}
		cout << endl;


/*  Image image( "500x300", "white" );
  Image image2( "bike_026.bmp" );
  image2.crop(Geometry(100,100,300,200));
  image2.scale(Magick::Geometry(32,32));
  image.composite(image2, 50, 20);
  image.write("test4.jpg");*/
  
      
  /*cout << "so far so good" << endl;
  vector<int> testv(10);
  cout << "so far so good" << endl;
  testv[5]++;
  cout << "so far so good" << endl;
  testv[5]++;
  cout << "so far so good" << endl;
  testv[7] = 1;
  cout << "so far so good" << endl;
  cout << "testv[3] " << testv[3] << endl;
  for (vector<int>::iterator p=testv.begin(); p!=testv.end(); ++p) {
    cout << *p << endl;
  }*/
  
  /* calculate EER
  if (argc > 1) {
    string sourcefile(argv[1]);
    calculateEER(sourcefile);
  }
  return (0);
  */
  
  /*   create groundtruth statistics
  bool error = true;
  if (argc == 4) {
    string imgFile(argv[1]);
    string groundtruthTxtFile(argv[2]);
    string statisticsOutputFilename(argv[3]);
    createTxtGroundtruthStatistics(imgFile, groundtruthTxtFile, statisticsOutputFilename);
    error = false;
  }
  if (argc == 3) {
    string groundtruthImgFile(argv[1]);
    string statisticsOutputFilename(argv[2]);
    createImgGroundtruthStatistics(groundtruthImgFile, statisticsOutputFilename);
    error = false;
  }
  if (error) {
    cerr << "wrong number of arguments" << endl;
    return (1);
  }
  return (0);
  */
  
}

